Subject: Removal of symlinked package resources fails

Description

The File System Resource Publisher removes invalid directories or symbolic links from the _Resources/Static/Packages/ folder. This
rarely happens, but it does happen if some package providing static resources is deactivated.

In that case FLOWS failed to remove the symbolic link because the removeDirectoriesRecursively() function did not consider symlinks
(only directories).

For reproducing this bug, use a TYPO3 Phoenix installation and let the TYPO3.ExtJS symlink in _Resources/Static/Packages/ point to
some invalid directory. On the next web hit, FLOW3 should crash.

Associated revisions

Revision af9ac039 - 2011-09-14 21:40 - Robert Lemke

[BUGFIX] Invalid static resource symlinks are removed again

Whenever the resource publishing of FLOWS finds an invalid
symbolic link in the static resources directory, it should
remove that link and re-publish the resources of the package

in question.

Because Utility\Files::removeDirectoryRecursively() could

not cope with symbolic links, this auto-cleanup failed.

This change set makes removeDirectoryRecursively() and
emptyDirectoryRecursively() symlink aware and sets its
behavior to not follow links but remove the links instead.
Change-Id: 12d5c544e6db728594209294cfe779b8bad3c6d59
Fixes: #29777

Revision 5adfc6f4 - 2011-09-17 20:05 - Robert Lemke
[BUGFIX] Invalid static resource symlinks are removed again
Whenever the resource publishing of FLOWS finds an invalid
symbolic link in the static resources directory, it should

remove that link and re-publish the resources of the package

in question.
Because Utility\Files::removeDirectoryRecursively() could

not cope with symbolic links, this auto-cleanup failed.

This change set makes removeDirectoryRecursively() and
emptyDirectoryRecursively() symlink aware and sets its
behavior to not follow links but remove the links instead.

Note: change set 12d5¢c544e6db728594209294cfe779b8bad3c6d59
did not completely fix the issue. If the old symbolic link

pointed to nowhere, the publishStaticResources() method

failed.

Change-Id: 130a27d60a93de8aeb7d27ea8030df6748d4af4aa
Fixes: #29777

History

#1 - 2011-09-14 14:34 - Mr. Hudson

- Status changed from Accepted to Under Review

Patch set 1 of change 12d5¢c544e6db728594209294cfe779b8bad3c6d59 has been pushed to the review server.

It is available at http://review.typo3.0rg/4970

#2 - 2011-09-14 21:40 - Mr. Hudson

Patch set 2 of change 12d5¢c544e6db728594209294cfe779b8bad3c6d59 has been pushed to the review server.

It is available at http://review.typo3.0rg/4970

#3 - 2011-09-14 22:05 - Robert Lemke
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:af9ac039850c0371d60d4e3d065d0dfc29af5795.
